/* See LICENSE file for copyright and license details. */

/* appearance */
static const unsigned int borderpx  = 2;        /* border pixel of windows */
static const unsigned int gappx     = 10;        /* gaps between windows */
static const unsigned int snap      = 100;       /* snap pixel */
static const unsigned int systraypinning = 0;   /* 0: sloppy systray follows selected monitor, >0: pin systray to monitor X */
static const unsigned int systrayonleft = 1;   	/* 0: systray in the right corner, >0: systray on left of status text */
static const unsigned int systrayspacing = 2;   /* systray spacing */
static const int systraypinningfailfirst = 1;   /* 1: if pinning fails, display systray on the first monitor, False: display systray on the last monitor*/
static const int showsystray        = 1;     /* 0 means no systray */
static const int showbar            = 1;     /* 0 means no bar */
static const int topbar             = 1;     /* 0 means bottom bar */
static const char *fonts[]          = { "terminus:size=9" };
static const char dmenufont[]       = "terminus:size=9";
static const char col_gray1[]       = "#222222";
static const char col_gray2[]       = "#444444";
static const char col_cyan[]        = "#7bbdbd";
static const char *colors[][3]      = {
	/*               fg         bg         border   */
	[SchemeNorm] = { col_cyan, col_gray1, col_gray2 },
	[SchemeSel]  = { col_gray1, col_cyan,  col_cyan  },
};


/* tagging */
static const char *tags[] = { "𝟙 >_ ", "𝟚  ", "𝟛  ", "𝟜  ", "𝟝  ", "𝟞  ", "𝟟  ", "𝟠  ", "𝟡  " };

static const Rule rules[] = {
	/* xprop(1):
	 *	WM_CLASS(STRING) = instance, class
	 *	WM_NAME(STRING) = title
	 */
	/* class      instance    title       tags mask     isfloating   monitor */
	{ "URxvt",  	NULL,       NULL,       1 << 0,             0,           -1 },
	{ "Xterm",  	NULL,       NULL,       1 << 0,             0,           -1 },
	{ "xterm",  	NULL,       NULL,       1 << 0,             0,           -1 },
	{ "Pcmanfm", 	NULL,       NULL,       1 << 1,             0,           -1 },
	{ "Thunar", 	NULL,       NULL,       1 << 1,             0,           -1 },
	{ "Xarchiver", 	NULL,       NULL,       1 << 1,             0,           -1 },
	{ "Firefox",  	NULL,       NULL,       1 << 2, 			0,           -1 },
	{ "firefox",  	NULL,       NULL,       1 << 2,      		0,           -1 },
	{ "Chromium",  	NULL,       NULL,       1 << 2,      		0,           -1 },
	{ "navigator", 	NULL,       NULL,       1 << 2,      		0,           -1 },
	{ "transmission-gtk", NULL, NULL,       1 << 2,      		0,           -1 },
	{ "Opera",  	NULL,       NULL,       1 << 2,      		0,           -1 },
	{ "Uzbl",     	NULL,       NULL,       1 << 2,      		0,           -1 },
	{ "Dillo",    	NULL,       NULL,       1 << 2,      		0,           -1 },
	{ "Surf",     	NULL,       NULL,       1 << 2,       	 	0,           -1 },
	{ "Netsurf-gtk3", NULL,     NULL,       1 << 2,       	 	0,           -1 },
	{ "Links",     	NULL,       NULL,       1 << 2,       	 	0,           -1 },
	{ "Putty",		NULL,    	NULL,       1 << 2,             0,           -1 },
	{ "Claws-mail", NULL,    	NULL,       1 << 3,             0,           -1 },
	{ "libreoffice", NULL,    	NULL,       1 << 3,             0,           -1 },
	{ "Orage", 		NULL,    	NULL,       1 << 3,             0,           -1 },
	{ "Thunderbird", NULL,    	NULL,       1 << 3,             0,           -1 },
	{ "Ciano", 		NULL,   	NULL,       1 << 4,             0,           -1 },
	{ "ClipGrab", 	NULL,   	NULL,       1 << 4,             0,           -1 },
	{ "Soundkonverter", NULL,   NULL,       1 << 4,             0,           -1 },
	{ "soundkonverter", NULL,   NULL,       1 << 4,             0,           -1 },
	{ "Vlc",      	NULL,       NULL,       1 << 4,             0,           -1 },
	{ "vlc",      	NULL,       NULL,       1 << 4,             0,           -1 },
	{ "Audacious", NULL,       "Audacious", 1 << 4,             0,           -1 },
	{ "Audacity", 	NULL,       NULL, 		1 << 4,             0,           -1 },
	{ "MPlayer",  	NULL,       NULL,       1 << 4,      		0,           -1 },
	{ "Xfburn",  	NULL,       NULL,       1 << 4,      		0,           -1 },
	{ "Geany",    	NULL,       NULL,       1 << 5,             0,           -1 },
	{ "Leafpad",  	NULL,       NULL,       1 << 5,             0,           -1 },
	{ "Mousepad",  	NULL,       NULL,       1 << 5,             0,           -1 },
	{ "Birdfont", 	NULL,       NULL,       1 << 6,             0,           -1 },
	{ "Blender",  	NULL,       NULL,       1 << 6,             1,           -1 },
	{ "Gimp",     	NULL,       NULL,       1 << 6,             1,           -1 },
	{ "Gpicview",   NULL,       NULL,       1 << 6,             1,           -1 },
	{ "Inkscape", 	NULL,       NULL,       1 << 6,             1,           -1 },
	{ "Gucharmap",  NULL,  		NULL,       1 << 7,      	 	0,           -1 },
	{ "Libfm-pref-apps",  NULL, NULL,       1 << 7,      	 	1,           -1 },
	{ "Lxappearance",  NULL,  	NULL,       1 << 7,      	 	0,           -1 },
	{ "Xfce4-taskmanager", NULL, NULL,      1 << 7,      	 	0,           -1 },
	{ "dosbox",  	NULL,       NULL,       1 << 8,       	 	1,           -1 },	
	{ "Dosbox",  	NULL,       NULL,       1 << 8,       	 	1,           -1 },
	{ "RetroArch",  NULL,       NULL,       1 << 8,       	 	1,           -1 },
	{ "Steam",  	NULL,       NULL,       1 << 8,       	 	1,           -1 },
	{ "Wine",  		NULL,       NULL,       1 << 8,       	 	1,           -1 },	

};

/* layout(s) */
static const float mfact     = 0.55; /* factor of master area size [0.05..0.95] */
static const int nmaster     = 1;    /* number of clients in master area */
static const int resizehints = 0;    /* 1 means respect size hints in tiled resizals */
static const int lockfullscreen = 1; /* 1 will force focus on the fullscreen window */

#include "fibonacci.c"
static const Layout layouts[] = {
	/* symbol     arrange function */
	{ "  >  ",      tile },    /* first entry is default */
	{ "  >  ",      NULL },    /* no layout function means floating behavior */
	{ "  >  ",      monocle },
 	{ "  >  ",      dwindle },
};

/* key definitions */
#define MODKEY Mod4Mask
#define TAGKEYS(KEY,TAG) \
	{ MODKEY,                       KEY,      view,           {.ui = 1 << TAG} }, \
	{ MODKEY|ControlMask,           KEY,      toggleview,     {.ui = 1 << TAG} }, \
	{ MODKEY|ShiftMask,             KEY,      tag,            {.ui = 1 << TAG} }, \
	{ MODKEY|ControlMask|ShiftMask, KEY,      toggletag,      {.ui = 1 << TAG} },

/* helper for spawning shell commands in the pre dwm-5.0 fashion */
#define SHCMD(cmd) { .v = (const char*[]){ "/bin/sh", "-c", cmd, NULL } }

/* commands */
static char dmenumon[2] = "0"; /* component of dmenucmd, manipulated in spawn() */
static const char *dmenucmd[] = { "dmenu_run_history", "-m", dmenumon, "-fn", dmenufont, "-nb", col_gray1, "-nf", col_cyan, "-sb", col_cyan, "-sf", col_gray1, NULL };
static const char *termcmd[]  = { "urxvt", NULL };
static const char *filecmd[]  = { "pcmanfm", NULL };
static const char *volup[]  = { "amixer", "set", "Master", "2dB+", NULL };
static const char *voldown[]  = { "amixer", "set", "Master", "2dB-", NULL };
static const char *soubory[]  = { "pcmanfm", NULL };
static const char *web[]  = { "firefox", NULL };
static const char *hudba[]  = { "urxvt", "-e", "cmus", NULL };
static const char *kalendar[]  = { "urxvt", "-e", "calcurse-online", NULL };
static const char *menu[]  = { "jgmenu_run", NULL };
static const char *killcmd[]  = { "xkill", NULL };

static Key keys[] = {
	/* modifier                     key        function        argument */
	{ MODKEY,                       XK_r,      spawn,          {.v = dmenucmd } },
	{ MODKEY,           	        XK_Return, spawn,          {.v = termcmd } },
	{ MODKEY|ShiftMask,             XK_Up,	   spawn,          {.v = volup } },
	{ MODKEY|ShiftMask,             XK_Down,   spawn,          {.v = voldown } },
	{ MODKEY,	               		XK_F1, spawn,              {.v = soubory } },
	{ MODKEY,	                	XK_F2, spawn,              {.v = web } },
	{ MODKEY,	                	XK_F3, spawn,              {.v = hudba } },
	{ MODKEY,	                	XK_Escape, spawn,          {.v = menu } },
	{ MODKEY,	                	XK_e, spawn,       		   {.v = menu } },
	{ MODKEY,	                	XK_semicolon,    view,     {.ui = ~0 } },
	{ MODKEY,                       XK_b,      togglebar,      {0} },
	{ MODKEY,	                	XK_Right,  focusstack,     {.i = +1 } },
	{ MODKEY,      		        	XK_Left,   focusstack,     {.i = -1 } },
	{ MODKEY,                       XK_Up,     incnmaster,     {.i = +1 } },
	{ MODKEY,                       XK_Down,   incnmaster,     {.i = -1 } },
	{ MODKEY,                       XK_h,      setmfact,       {.f = -0.05} },
	{ MODKEY,                       XK_l,      setmfact,       {.f = +0.05} },
	{ MODKEY|ShiftMask,             XK_Return, zoom,           {0} },
	{ MODKEY,                       XK_Tab,    view,           {0} },
	{ MODKEY,	                	XK_q,      killclient,     {0} },
	{ MODKEY,                       XK_t,      setlayout,      {.v = &layouts[0]} },
	{ MODKEY,                       XK_f,      setlayout,      {.v = &layouts[1]} },
	{ MODKEY,                       XK_m,      setlayout,      {.v = &layouts[2]} },
	{ MODKEY,                       XK_r,      setlayout,      {.v = &layouts[3]} },
	{ MODKEY|ShiftMask,             XK_r,      setlayout,      {.v = &layouts[4]} },
	{ MODKEY,                       XK_space,  layoutscroll,   {.i = +1 } },
	{ MODKEY|ShiftMask,             XK_space,  togglefloating, {0} },
	{ MODKEY,                       XK_0,      view,           {.ui = ~0 } },
	{ MODKEY|ShiftMask,             XK_0,      tag,            {.ui = ~0 } },
	{ MODKEY,                       XK_comma,  focusmon,       {.i = -1 } },
	{ MODKEY,                       XK_period, focusmon,       {.i = +1 } },
	{ MODKEY|ShiftMask,             XK_Left,  tagmon,         {.i = -1 } },
	{ MODKEY|ShiftMask,             XK_Right, tagmon,         {.i = +1 } },
	TAGKEYS(                        XK_plus,                      0)
	TAGKEYS(                        XK_ecaron,                      1)
	TAGKEYS(                        XK_scaron,                      2)
	TAGKEYS(                        XK_ccaron,                      3)
	TAGKEYS(                        XK_rcaron,                      4)
	TAGKEYS(                        XK_zcaron,                      5)
	TAGKEYS(                        XK_yacute,                      6)
	TAGKEYS(                        XK_aacute,                      7)
	TAGKEYS(                        XK_iacute,                      8)
	{ MODKEY|ShiftMask,             XK_q,      quit,           	{0} },

};


/* button definitions */
/* click can be ClkTagBar, ClkLtSymbol, ClkStatusText, ClkWinTitle, ClkClientWin, or ClkRootWin */
static Button buttons[] = {
	/* click                event mask      button          function        argument */
	{ ClkLtSymbol,          0,              Button1,        layoutscroll,   {.i = +1 } },
	{ ClkLtSymbol,          0,              Button2,        layoutscroll,   {.i = -1 } },
	{ ClkLtSymbol,          0,              Button3,        layoutscroll,   {.i = -1 } },
	{ ClkLtSymbol,          0,              Button4,        setmfact,       {.f = +0.05} },
	{ ClkLtSymbol,          0,              Button5,        setmfact,       {.f = -0.05} },
	{ ClkWinTitle,          0,              Button1,        zoom,           {0} },
	{ ClkWinTitle,          0,              Button2,        togglefloating, {0} },
	{ ClkWinTitle,          0,              Button3,        setlayout,      {0} },
	{ ClkWinTitle,          0,              Button4,        focusstack,     {.i = +1 } },
	{ ClkWinTitle,          0,              Button5,        focusstack,     {.i = -1 } },
	{ ClkStatusText,        0,              Button1,        spawn,          {.v = menu } },
	{ ClkStatusText,        0,              Button2,        spawn,          {.v = killcmd } },
	{ ClkStatusText,        0,              Button3,        spawn,          {.v = menu } },
	{ ClkStatusText,        0,              Button4,        spawn,          {.v = volup } },
	{ ClkStatusText,        0,              Button5,        spawn,          {.v = voldown } },
	{ ClkClientWin,         MODKEY,         Button1,        movemouse,      {0} },
	{ ClkClientWin,         MODKEY,         Button2,        togglefloating, {0} },
	{ ClkClientWin,         MODKEY,         Button3,        resizemouse,    {0} },
	{ ClkClientWin,         MODKEY,         Button4,        setmfact,       {.f = +0.05} },
	{ ClkClientWin,         MODKEY,         Button5,        setmfact,       {.f = -0.05} },
	{ ClkTagBar,            0,              Button1,        view,           {0} },
	{ ClkTagBar,            0,              Button2,        view,           {.ui = ~0 } },
	{ ClkTagBar,            0,              Button3,        toggleview,     {0} },
	{ ClkTagBar,            0,              Button4,        layoutscroll,   {.i = +1 } },
	{ ClkTagBar,            0,              Button5,        layoutscroll,   {.i = -1 } },
	{ ClkTagBar,            MODKEY,         Button1,        tag,            {0} },
	{ ClkTagBar,            MODKEY,         Button3,        toggletag,      {0} },
	{ ClkRootWin,           0,              Button1,        spawn,          {.v = menu } },
	{ ClkRootWin,           0,              Button2,        spawn,          {.v = menu } },
	{ ClkRootWin,           0,              Button3,        spawn,          {.v = menu } },
};

